<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_SupplementRelPax ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_SupplementRelPax extends AbstractStructArrayBase
{
    /**
     * The SupplementRelPax
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_SupplementRelPax[]
     */
    public $SupplementRelPax;
    /**
     * Constructor method for ArrayOfJP_SupplementRelPax
     * @uses ArrayOfJP_SupplementRelPax::setSupplementRelPax()
     * @param \StructType\JP_SupplementRelPax[] $supplementRelPax
     */
    public function __construct(array $supplementRelPax = array())
    {
        $this
            ->setSupplementRelPax($supplementRelPax);
    }
    /**
     * Get SupplementRelPax value
     * @return \StructType\JP_SupplementRelPax[]|null
     */
    public function getSupplementRelPax()
    {
        return $this->SupplementRelPax;
    }
    /**
     * Set SupplementRelPax value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_SupplementRelPax[] $supplementRelPax
     * @return \ArrayType\ArrayOfJP_SupplementRelPax
     */
    public function setSupplementRelPax(array $supplementRelPax = array())
    {
        foreach ($supplementRelPax as $arrayOfJP_SupplementRelPaxSupplementRelPaxItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_SupplementRelPaxSupplementRelPaxItem instanceof \StructType\JP_SupplementRelPax) {
                throw new \InvalidArgumentException(sprintf('The SupplementRelPax property can only contain items of \StructType\JP_SupplementRelPax, "%s" given', is_object($arrayOfJP_SupplementRelPaxSupplementRelPaxItem) ? get_class($arrayOfJP_SupplementRelPaxSupplementRelPaxItem) : gettype($arrayOfJP_SupplementRelPaxSupplementRelPaxItem)), __LINE__);
            }
        }
        $this->SupplementRelPax = $supplementRelPax;
        return $this;
    }
    /**
     * Add item to SupplementRelPax value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_SupplementRelPax $item
     * @return \ArrayType\ArrayOfJP_SupplementRelPax
     */
    public function addToSupplementRelPax(\StructType\JP_SupplementRelPax $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_SupplementRelPax) {
            throw new \InvalidArgumentException(sprintf('The SupplementRelPax property can only contain items of \StructType\JP_SupplementRelPax, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->SupplementRelPax[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_SupplementRelPax|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_SupplementRelPax|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_SupplementRelPax|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_SupplementRelPax|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_SupplementRelPax|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SupplementRelPax
     */
    public function getAttributeName()
    {
        return 'SupplementRelPax';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJP_SupplementRelPax
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
